/**
 * @author: Klaus Dingemann, Münster
 * @version: 10.07.2015
 */
import sas.*;
import java.awt.Color;
public class Fisch2 {
  private Picture fisch;
  
  public Fisch2() {
    fisch = new Picture(200,170,76,60,"fisch.png");
  }

  public void reset() {
      fisch.moveTo(200,170);
  }
  
  public void bewege(int pD){
    fisch.move(pD);
    wendeAmRand(pD);
  }
 
  public void dreheNach(double pX, double pY) {
    double alteRichtung = fisch.getDirection();
    double neueRichtung = Tools.getDirection(fisch.getCenterX(), fisch.getCenterY(), pX, pY);
    fisch.turnTo(neueRichtung);
    ausrichten(alteRichtung, neueRichtung);
  }
  
  private void wendeAmRand(int pD) {
    double richtung = fisch.getDirection();
    if (fisch.getShapeX() < 0  ||  fisch.getShapeX()+fisch.getShapeWidth()>800) {
      fisch.turnTo(360 - richtung);
      fisch.move(2*pD);
      ausrichten(richtung, fisch.getDirection());
    } else {
      if (fisch.getShapeY() < 40 || fisch.getShapeY() + fisch.getShapeHeight() > 400) {
        fisch.turnTo(180-richtung);
        fisch.move(2*pD);
        ausrichten(richtung, fisch.getDirection());
      } 
    }
  }


  private void ausrichten(double pAlteRichtung, double pNeueRichtung){
    if (pAlteRichtung <= 180 && pNeueRichtung >= 180) {        
      fisch.turn(270 - pNeueRichtung);
      fisch.flipVertical();
      fisch.turn(pNeueRichtung - 270);
    } else if (pAlteRichtung >= 180 && pNeueRichtung <= 180) {
        fisch.turn(90 - pNeueRichtung);
        fisch.flipVertical();
        fisch.turn(pNeueRichtung - 90);
    } 
  }
    
  public Picture gibGrafik() {
     return fisch;
    }
}