/**
 * @author: Klaus Dingemann, Münster
 * @version: 10.07.2015
 */
import sas.*;
import java.awt.Color;
public class Futter
{
    private Plankton[] futter;
    private int anzahl;
    private Picture planktonBild;
    private int maxZahl;
  
    public Futter(int pAnzahl) {
       anzahl = pAnzahl;
       maxZahl = pAnzahl;
       futter = new Plankton[anzahl];
       planktonBild = new Picture(200,-100,20,10,"plankton.png");
       for (int i = 0; i < anzahl; i++) {
           //Ein neues Plankton wird an eine zufällige Position gesetzt
           int x = Tools.randomNumber(30, 770);
           int y = Tools.randomNumber(60, 340);
           futter[i] = new Plankton(x, y, planktonBild);
       }
    }
    
    public void reset(){
        anzahl = maxZahl;
        for (int i = 0; i<anzahl; i++) {
            futter[i].entferne();
            int x = Tools.randomNumber(30, 770);
            int y = Tools.randomNumber(60, 340);
            futter[i] = new Plankton(x, y, planktonBild);
        }
    }
    
    public void entferne(int pNr){
       futter[pNr].entferne();
       for (int j=pNr; j<anzahl-1; j++) {
           futter[j]=futter[j+1];
       }
       anzahl = anzahl - 1;
    }
    
    public void bewege(int pDistanz) {
        for (int i = 0; i < anzahl; i++) {
            futter[i].bewege(pDistanz);
        }
    }
    
    public int sucheFutter(Fisch2 pFisch){
        int treffIndex = 0;
        boolean treffer = false;
        while (!treffer && treffIndex < anzahl){
            if (futter[treffIndex].wirdGefressen(pFisch)) {
                treffer=true;
            } else {
                treffIndex++;
              }
        }
        if (treffer) {
            return treffIndex;
        } else {
            return -1;
        }  
    }        
    
}