import sas.*; // Import der SaS-Bibliothek
import sasio.*;
import java.awt.Color; // Import der Klasse Color, um einfacher auf die Farben zuzugreifen.

class Autorennen
{
    // Deklarationen
    View fenster;    
    Auto auto1;
    Rennstrecke strecke;
    Rectangle auto;
    int rundenzahl;
    boolean rundeZaehlen;
    Text rundenAnzeige;
    // Konstruktor dieser Klasse
    Autorennen()
    {
        // Initialisierungen
        fenster = new View(800,650,"SaS-Programm");
        fenster.setBackgroundColor(Color.GREEN);
        strecke = new Rennstrecke();
        auto1 = new Auto();
        rundenzahl = 3;
        rundenAnzeige = new Text(600, 20, "Runden 3");
        rundeZaehlen = false;
        auto1.zumStart(440, 110, 114);
    }
    
    public void highScore(String dateiname) {
     String[] eintraege = StringFileTools.loadFileInStringArray(dateiname);
     String zeitstring = eintraege[0].substring(eintraege[0].indexOf("#")+1,eintraege[0].length());
     double zeit = timeToDouble(zeitstring);
     String minName = eintraege[0].substring(0,eintraege[0].indexOf("#"));
     double minZeit = zeit;
     int minIndex = 0;
     for (int i = 1; i < eintraege.length; i++) {
         zeitstring = eintraege[i].substring(eintraege[i].indexOf("#")+1,eintraege[i].length());
         zeit = timeToDouble(zeitstring);
         if (zeit < minZeit) {
             minZeit = zeit;
             minIndex = i;
             minName = eintraege[i].substring (0,eintraege[i].indexOf("#"));
         }
     }
     Tools.message(minName+" "+minZeit, "Bestzeit");
  }
  
  public double timeToDouble(String time) {
      String sekunden = time.substring(0, time.indexOf(","));
      String zehntel = time.substring(time.indexOf(",")+1,time.length());
      return Tools.stringToDouble(sekunden+"."+zehntel);
 }
         
  public void speichern(String dateiname, String datensatz) {
      if (!StringFileTools.fileExists(dateiname)) {
          StringFileTools.writeInFile(dateiname,datensatz);
      } else {
          StringFileTools.appendToFile(dateiname, datensatz);
        }
  }
    void spielstarten()
    {
        String name = Tools.inputDialog("Geben Sie Ihren Namen an");
        long zeit = Tools.getStartTime();
        while(!fenster.keyBackspacePressed() && rundenzahl>0)
        {
            
            if(fenster.keyRightPressed())
            {
                auto1.lenkeRechts();
                
            }
            
            if(fenster.keyLeftPressed())
            {
                auto1.lenkeLinks();
                
            }
            
            if(fenster.keyUpPressed())
            {
              if (strecke.aufStrecke(auto1)) {
                auto1.fahre(5);
              }
            }
            
            if(fenster.keyDownPressed())
            {
               auto1.fahre(-5);
            }
        
            if (strecke.rundeGefahren(auto1)) {
                rundenzahl = rundenzahl - 1;
                rundenAnzeige.setText("Runden "+rundenzahl);
            }
            fenster.wait(20);
        }
        String gefahreneZeit = Tools.getElapsedTimeString(zeit);
        new Text(500, 550,"Gefahrene Zeit: "+gefahreneZeit+" Sekunden");
        speichern("highscoreAutorennen.txt",name+"#"+gefahreneZeit);
        highScore("highscoreAutorennen.txt");
    }
}