/**
 * Autor: Klaus Dingemann, Münster
 * Version: 10.07.2015 
 */
import sas.*;
import java.awt.Color;
public class BaelleFangen{
   private View view;
   private Circle[] baelle = new Circle[20];
   private Rectangle korb;
   private Text anzahl;
 
    BaelleFangen()
    {   view = new View (600,400,"Bälle fangen");
        view.setBackgroundColor(Color.yellow);
        anzahl = new Text(10,10,"Gefangen: 0",Color.RED);
        erzeugeBaelle();
        korb = new Rectangle(375, 340, 50,60,Color.green);
    }

   void erzeugeBaelle(){
      for (int i=0;i<20;i++){
          int x = Tools.randomNumber(20,570);
          int y = Tools.randomNumber(-400,-10);
          Circle ball = new Circle(x, y, 15,Color.blue);
          baelle[i]=ball;
      }
    }
    
   
    
    void fuehreAus(){
       int gefangen=0;
       long start = Tools.getStartTime();
        while(gefangen<20){
            // nicht gefangene Bälle außerhalb des Fenster nach oben verschieben
            for (int i=0;i<20;i++) {

             if (baelle[i].getShapeY() > 400) {
                 baelle[i].moveTo(Tools.randomNumber(10,570),Tools.randomNumber(-150,-10));
                 baelle[i].setColor(Color.BLUE);
            }
    
            }
            // Korb nach Tastatureingabe nach rechts oder links bewegen
            if (view.keyLeftPressed()) {
                korb.move(-10,0);
            } else
              if (view.keyRightPressed()) {
                 korb.move(10,0);
               } else {
                  //nicht erlaubte Tastendrücke löschen
                  view.keyBufferDelete();
                }
           //Bälle bewegen und pruefen, ob einer im Korb gelandet ist
           for (int zaehler=0; zaehler<20;zaehler++){
              baelle[zaehler].move(0,5);
              //Bälle, die neben dem Korb sind werden orange gekennzeichnet, Können nicht mehr gefangen werden
              if (baelle[zaehler].getShapeY()+30 > 340 && !baelle[zaehler].intersects(korb))
              { 
                  baelle[zaehler].setColor(Color.ORANGE);
                }
              if (korb.contains(baelle[zaehler]) && !baelle[zaehler].getHidden() && 
                  !(baelle[zaehler].getColor()  == Color.ORANGE))  {
                 gefangen = gefangen + 1;
                 anzahl.setText("Gefangen: "+gefangen);
                 baelle[zaehler].setHidden(true);
                }
                
           }
            view.wait(50);
        }
         String stop = Tools.getElapsedTimeString(start);
         //Verbrauchte Zeit anzeigen
         Text ergebnis = new Text(10, 50,"Zeit: "+stop+" Sekunden", Color.red);
      }
      
      static void main() {
          BaelleFangen bf = new BaelleFangen();
          bf.fuehreAus();
   }
}
