/**
 * Autor: Klaus Dingemann, Münster
 * Version: 17.11.2015
 */
 import sas.*;
 import sasio.*;
 import java.awt.Color;
 class BaelleKlickenHighScore{
   final int ANZAHLBAELLE=20;
   final int BREITE=800;
   final int HOEHE=600;
   final int GESCHWINDIGKEIT = 3;
   final int RADIUSMAX = 25;
   final int RADIUSMIN = 10;
   View view;
   Circle[] baelle = new Circle[ANZAHLBAELLE];
   int anzahlGetroffen = 0;
   Text zeit;
 
  BaelleKlickenHighScore() {
    view = new View(BREITE, HOEHE,"Bälle");
    view.setBackgroundColor(Color.blue);
    for (int i=0;i<ANZAHLBAELLE;i++){
        int radius = Tools.randomNumber(RADIUSMIN, RADIUSMAX);
        int xPosition = Tools.randomNumber(0,BREITE-2*radius);
        int yPosition = Tools.randomNumber(-2*radius,-HOEHE);
        Circle ball = new Circle(xPosition, yPosition, radius, Color.RED);
        ball.moveTo(xPosition,yPosition);
        baelle[i]=ball;
    }
    zeit = new Text(10, 50,"Zeit: n", Color.YELLOW);   
    zeit.setHidden(true);
  }

  boolean alleGefangen(){
       return anzahlGetroffen == ANZAHLBAELLE;
  }
    
   
   boolean ausserhalb (int i){
      return baelle[i].getShapeY() > HOEHE;
   }    
      
   public void bewegeBall(int i){
      baelle[i].move(0,GESCHWINDIGKEIT);
   }
   
   boolean ballGetroffen(int i){
     if (baelle[i].mousePressed()) {
         return true;
        } else {
            return false;
        }
   }
  
  public void highScore(String dateiname) {
     String[] eintraege = StringFileTools.loadFileInStringArray(dateiname);
     String zeitstring = eintraege[0].substring(eintraege[0].indexOf("#")+1,eintraege[0].length());
     double zeit = timeToDouble(zeitstring);
     String minName = eintraege[0].substring(0,eintraege[0].indexOf("#"));
     double minZeit = zeit;
     double minIndex = 0;
     for (int i = 1; i < eintraege.length; i++) {
         zeitstring = eintraege[i].substring(eintraege[i].indexOf("#")+1,eintraege[i].length());
         zeit = timeToDouble(zeitstring);
         if (zeit < minZeit) {
             minZeit = zeit;
             minIndex = i;
             minName = eintraege[i].substring (0,eintraege[i].indexOf("#"));
         }
     }
     Tools.message(minName+" "+minZeit, "Bestzeit");
  }
         
  public double timeToDouble(String time) {
      String sekunden = time.substring(0, time.indexOf(","));
      String zehntel = time.substring(time.indexOf(",")+1,time.length());
      return Tools.stringToDouble(sekunden+"."+zehntel);
 }
         
  public void speichern(String dateiname, String datensatz) {
      if (!StringFileTools.fileExists(dateiname)) {
          StringFileTools.writeInFile(dateiname,datensatz);
      } else {
          StringFileTools.appendToFile(dateiname, datensatz);
        }
  }
   
  void fuehreAus(){
       long start = Tools.getStartTime(); 
       String name = Tools.inputDialog("Geben Sie Ihren Namen an");
        while(!alleGefangen()){
          for (int i = 0;i < ANZAHLBAELLE;i++) {

             if (ausserhalb(i)){
                 //Bälle nach oben verschieben, wenn unten herausgefallen
                 baelle[i].moveTo(baelle[i].getShapeX(), baelle[i].getShapeY()-HOEHE);
             }
             bewegeBall(i);
             if (ballGetroffen(i)){
                 //geklickte Bälle verstecken
                 baelle[i].setHidden(true);
                 anzahlGetroffen = anzahlGetroffen+1;
             }
          }    
          view.wait(20);
        }
        String stop = Tools.getElapsedTimeString(start);  
        zeit.setText("Zeit: "+stop+" Sekunden"); 
        zeit.setHidden(false);
        speichern("highscoreKlicken.txt",name+"#"+stop);
        highScore("highscoreKlicken.txt");
   }
   
   static void main(){
       BaelleKlickenHighScore bk = new BaelleKlickenHighScore();
       bk.fuehreAus();
   }
}