import sas.*;
import sasio.*;
import java.awt.Color;
public class Spielfeld
{
 
    private final Color HELLBRAUN = new Color(255,127,36);;
    private final Color HELLBLAU = new Color(99, 184,255);
    private View view;

    private Rectangle gehaeuse;
    private Circle[][] eingabeCode;
    private Circle[][] ergebnisse;
    private Circle[] code;
    private Rectangle sichtblende;
    private Color[] farben;
    private Button pruefenbtn;
    private Text reihenNr;
    
    public Spielfeld() {
        view = new View(270, 700, "Mastermind");
        gehaeuse = new Rectangle(0,0,270, 660, new Color(139,69,19));
        eingabeCode = new Circle[12][4];
        ergebnisse = new Circle[12][4];
        code = new Circle[4];
        for (int i = 0; i<12; i++) {
            for (int j = 0; j<4; j++) {
                eingabeCode [i][j] = new Circle(110+50*(j-1), 610 - 50*i, 20, HELLBRAUN);
            }
        }  
        for (int j = 0; j< 4; j++) {
           code [j] = new Circle(110+50*(j-1), 10, 20, HELLBRAUN);
        }
        sichtblende = new Rectangle(0,0,270,50, Color.RED);
        sichtblende.setHidden(false);
        for (int i = 0; i<12; i++) {
                ergebnisse [i][0] = new Circle(10, 610 - 26 - 50*(i-1) , 6, HELLBRAUN);
                ergebnisse [i][1] = new Circle(30, 610 - 26- 50*(i-1), 6, HELLBRAUN);
                ergebnisse [i][2] = new Circle(10, 610 - 46- 50*(i-1), 6, HELLBRAUN);
                ergebnisse [i][3] = new Circle(30, 610 - 46- 50*(i-1), 6, HELLBRAUN);
            }
        pruefenbtn = new Button(90,670, 90, 20, "prüfen", Color.GREEN);
        reihenNr = new Text(5,665,"1");
        reihenNr.setFontSansSerif(true,30);
    }  
        
    
      private Color gibNaechsteFarbe(Color aktuelleFarbe) {
         Color farbe = Color.LIGHT_GRAY;
          if (aktuelleFarbe == HELLBRAUN) {
            farbe = Color.GREEN;
         } else if (aktuelleFarbe == Color.GREEN) {
             farbe = Color.RED; 
         } else if  (aktuelleFarbe ==  Color.RED) { 
             farbe = Color.BLUE;
         } else if (aktuelleFarbe == Color.BLUE) {
             farbe = Color.YELLOW;
          } else if (aktuelleFarbe == Color.YELLOW) {
             farbe = HELLBLAU;
          } else if (aktuelleFarbe == HELLBLAU) {
             farbe = Color.MAGENTA;
          } else if (aktuelleFarbe == Color.MAGENTA) {
             farbe = Color.GREEN;
          }  
          return farbe; 
      }
    
      public void farbenWaehlen(int reihe) {
          boolean pruefen = false;
          int nr = reihe+1;
          reihenNr.setText(""+nr);
          while (!pruefen) {
              for (int i = 0; i<4; i++) {
                  if (eingabeCode[reihe][i].mouseClicked()) {
                      Color aktuelleFarbe = eingabeCode[reihe][i].getColor();
                      eingabeCode[reihe][i].setColor(gibNaechsteFarbe(aktuelleFarbe));
                  } 
              } 
              if (pruefenbtn.clicked()){
                  pruefen = true;
              } 
              view.wait(10);
          } 
      } 
      
      public void zeigeErgebnis(int reihe, int schwarz, int weiss) {
        for (int i=0; i<schwarz; i++) {
            ergebnisse[reihe][i].setColor(Color.BLACK);
        } for (int j = schwarz; j < schwarz+weiss; j++) {
             ergebnisse[reihe][j].setColor(Color.WHITE);
          }  
      }
              
       public void erzeugeCode() {
           Color farbe=Color.LIGHT_GRAY;
           for (int i = 0; i<4; i++) {
               int zufallsfarbe = Tools.randomNumber(0, 5);
               switch (zufallsfarbe) {
                   case 0:farbe = Color.GREEN; break;
                   case 1:farbe = Color.RED; break;
                   case 2:farbe = Color.BLUE; break;
                   case 3:farbe = Color.YELLOW; break;
                   case 4:farbe = HELLBLAU; break;
                   case 5:farbe = Color.MAGENTA; break;
                }
                code[i].setColor(farbe);
            }
        }
 
        public int gibAnzahlPosUndFarbeRichtig(int reihe) {
            int anzahl = 0;
            for (int i = 0; i<4; i++) {
                if (eingabeCode[reihe][i].getColor() == code[i].getColor()) {
                    anzahl = anzahl + 1;
                }
            }
            return anzahl;
        }
        
        
        private int gibFarbNr(Color farbe) {
            if (farbe == Color.GREEN) {
               return 0;
            } else if (farbe == Color.RED) {
               return 1;
            } else if (farbe == Color.BLUE) {
               return 2;
            } else if (farbe == Color.YELLOW) {
               return 3;
            } else if (farbe == HELLBLAU) {
               return 4;
            } else if (farbe == Color.MAGENTA){ 
               return 5;
           } else
              return -1;
      
        }
        
        
        private int minimum(int zahl1, int zahl2) {
            if (zahl1 < zahl2) {
                return zahl1;
            } else {
                return zahl2;
            }
        }
        
        public int gibAnzahlFarbeRichtig(int reihe) {
            int anzahl = 0;
            int[] farbenCode = new int[6];
            int[] farbenEingabe = new int[6];
            for (int i = 0; i<6; i++) {
                farbenCode[i] = 0;
                farbenEingabe[i] = 0;
            }
            for (int i = 0; i<4; i++) {
                //Häufigkeit der noch nciht erratenen Farben im Code bestimmten
                if (eingabeCode[reihe][i].getColor() != code[i].getColor()) {
                    int farbNrCode = gibFarbNr(code[i].getColor());
                    if (farbNrCode >-1) {
                       farbenCode[farbNrCode]++;
                    } 
                    //Häufigkeit der noch nicht erraten Zahlen in der Lösungsreihe bestimmen
                    int farbNrEingabe = gibFarbNr(eingabeCode[reihe][i].getColor());
                    if (farbNrEingabe > -1) {
                      farbenEingabe[farbNrEingabe]++;
                    }
                }
            }
            for (int i = 0; i<6; i++) {
                anzahl = anzahl + minimum(farbenCode[i], farbenEingabe[i]);
            }
            return anzahl;
        }
        
        public void zeigeLoesung() {
            sichtblende.setHidden(true);
        }
        
}

    

