import sasio.*;
import sas.Tools;
public class Computer
{
    
    private Spielfeld spielfeld;  
    private  int[][] chipsBinaer = new int[5][4];

    
    public Computer(Spielfeld pSpielfeld)
    {
        spielfeld = pSpielfeld;
    }

    private int[] dezInBinaer(int zahl) {
        int[] binaerArray = new int [4];
        for (int i = 0; i < 4; i++) {
           binaerArray[i] = zahl % 2;
           zahl = zahl / 2;
        }
        return binaerArray;
    }
    
    public int binaerInDez(int[] binaerArray) {
        int zahl = 0;
        for (int i = 3; i >= 0; i--) {
            zahl = zahl*2 + binaerArray[i];
        }
        return zahl;
    }    
    
    private int[] binaerSumme() {
        int[] binaerSumme = new int [4];
        for (int i = 0; i < 4; i++) {
            binaerSumme[i] = chipsBinaer[0][i];
        }
        for (int j = 1; j < 5; j++) {
          for (int i = 0; i < 4; i++) {
              binaerSumme[i] = (binaerSumme[i] + chipsBinaer[j][i]) % 2;
          }
        }
        return binaerSumme;
    }
    
    private void chipsBinaer() {
      for (int i = 0; i<5; i++) {
        chipsBinaer[i] = dezInBinaer(spielfeld.gibAnzahlChips(i));
      }
    }
    
    private int[] berechneZug(int[] binaerSumme) {
        int schale = -1;
        int j = 0;
        int zug[] = new int[2];
        int[] summe = new int[4];
        int summeDezimal = 0;
        int chipsDezimal = 0;
        j = 0;
        while (schale == -1 && j < 5) {
            for (int i=0; i<4; i++) {
                summe[i] = (chipsBinaer[j][i] + binaerSumme[i]) % 2;
            }
            summeDezimal = binaerInDez(summe);
            chipsDezimal = spielfeld.gibAnzahlChips(j);
            if (summeDezimal < chipsDezimal) {
                schale = j;
            } else {
                if (j < 5) {
                    j = j+1;
                }
            }
        }
     
        if (schale == -1) {
            j = 0;
            while (spielfeld.gibAnzahlChips(j) == 0) {
                j = j + 1;
            }
            zug[0] = j;
            zug[1] = 1;
        } else {
            zug[0] = schale;
            zug [1] = spielfeld.gibAnzahlChips(schale) - summeDezimal;
        }
        return zug;
    }
            
 
    public void computerZug()
    {
       chipsBinaer();  
       int[] binaerSumme = binaerSumme();
       int[] zug = new int[2];
       zug = berechneZug(binaerSumme);
       int schale = zug[0]+1;
       Tools.message("Der Computer nimmt "+zug[1]+" Chips aus Schale " + schale,"Computerzug");
       spielfeld.nimmWeg(zug[0], zug[1]);
      
    }
}