/**
 * Implementation des Nim-Spiels gegen den Computer
 * @author: Klaus Dingeman
 * @version: 04.03.2018
*/
import sas.*;
import sasio.*;
public class NIM
{
    private View view;
    private Spielfeld spielfeld;
    private Spieler spieler;
    private Computer computer;
    private boolean spielBeendet;
    /**
     * Konstruktor für Objekte der Klasse NIM
     */
    public NIM()
    {
       view = new View(800, 400, "NIM"); 
       spielfeld = new Spielfeld(view);
       spieler = new Spieler(spielfeld);
       computer = new Computer(spielfeld);
       spielBeendet = false;
    }

    public void siegerNachricht(char sieger) {
        
        String s = "";
        if (sieger=='c') {
            s = "Der Computer hat gewonnen.";
        } else {
            s = "Herzlichen Glückwunsch, du hast gewonnen.";
        }
        Tools.message(s,"Gewinner");
    }
    
    public void spielen() {
        char sieger = 'c';
        while (!spielBeendet) {
           spieler.spielerZug();
           if (spielfeld.spielBeendet()) {
               spielBeendet = true;
               sieger = 's';
           } else {
               computer.computerZug();
               if (spielfeld.spielBeendet()) {
                   spielBeendet = true;
               } 
             }   
           view.wait(10);
        }
        siegerNachricht(sieger);
    }
    
    public static void main() {
        NIM nim = new NIM();
        nim.spielen();
   }
}
