import sas.*;
import sasio.*;
import java.awt.Color;
class Spielfeld {
    private Schale[] schalen = new Schale[5];
    private Textfield[] txtfldEingabe = new Textfield[5];
    private View view;
    
    public Spielfeld(View pView) {
        view = pView;
        Text titel = new Text(350, 40, "NIM", Color.RED);
        titel.setFontSerif(true, 32);
        for (int i=0; i<5; i++) {
            int nr = i+1;
            new Text(55+i*150, 120, "Schale "+nr, Color.BLACK);
            schalen[i] = new Schale(50+i*150, 150,100, Color.BLACK);
            txtfldEingabe[i] = new Textfield(85+i*150, 270,30,20,"",view);
        }
        new Text(50, 310, "Eingabefeld klicken, Anzahl der Steine eingeben und <Enter> drücken");
        verteileChips();
    }
    
    public void verteileChips() {
        int schaleNr;
        for (int i = 0; i<40; i++) {
            Circle chip = new Circle(0,0,8,Color.RED);
            do
               schaleNr = Tools.randomNumber(0,4);
            while (schalen[schaleNr].gibAnzahlChips() == 15);
            schalen[schaleNr].inhaltHinzu(chip);
        }
    }
    
    
    public void ziehen() {
        boolean zugKorrekt = false;
        int fokus = 0;
        while (!zugKorrekt) {
            for (int i=0; i<5; i++) {
                if (txtfldEingabe[i].clicked()) {
                    txtfldEingabe[fokus].setActivated(false);
                    fokus = i;
                    txtfldEingabe[fokus].setActivated(true);
                }
            }
            if (txtfldEingabe[fokus].enterPressed()) {
                int zug = Tools.stringToInt(txtfldEingabe[fokus].getText());
                if (zug > 0 && zug <= schalen[fokus].gibAnzahlChips()) {
                    schalen[fokus].inhaltEntfernen(zug);
                    txtfldEingabe[fokus].deleteText();
                    txtfldEingabe[fokus].setActivated(false);
                    zugKorrekt = true;
                } else {
                    zugKorrekt = false;
                    txtfldEingabe[fokus].setActivated(true);
                    Tools.message("Kein korrekter Zug", "Fehler");
                }
            }
        }
    }
    
    public boolean spielBeendet(){
        int summe = 0;
        for (int i = 0; i < 5; i++) {
          summe = summe + schalen[i].gibAnzahlChips();     
        }
        return summe == 0;
    }
    
    public void nimmWeg(int schaleNr, int anzahl) {
        schalen[schaleNr].inhaltEntfernen(anzahl);
    }
    
    public int gibAnzahlChips(int schaleNr) {
        return schalen[schaleNr].gibAnzahlChips();
    }
}
