
/**
 * Nim:Spiel Zwei Spieler ziehen abwechselnd 1 bis 3 Steine.
 * Wer den letzten Stein nimmt verliert.
 * 
 * @author Klaus Dingemann
 * @version 18.1.2018
 */
import sas.*;
import java.awt.Color;
import sasio.*;
public class NimGUI
{
    final String sp1AmZug="Spieler 1 zieht";
    final String sp2AmZug="Spieler 2 zieht";
    final String sieg1="Gewinner: Spieler 1";
    final String sieg2="Gewinner: Spieler 2";
    View view;
    Button btnNim1;
    Button btnNim2;
    Button btnNim3;
    Button btnNeuesSpiel;
    Button btnEnde;
    Label lblSteinAnzahl;
    Label lblAusgabe;
    NimSpiel nim;
    boolean programmEnde;
    
   
    public NimGUI() {
        view = new View(200, 300, "Nimm 15");
        view.setBackgroundColor(Color.LIGHT_GRAY);
        lblSteinAnzahl = new Label(10,10,100,30,"Steinanzahl: 15", Color.LIGHT_GRAY, false, false);
        btnNim1 = new Button(50, 50, 100, 20, "Nimm 1", Color.YELLOW);
        btnNim2 = new Button(50, 90, 100, 20, "Nimm 2", Color.YELLOW);
        btnNim3 = new Button(50, 130, 100, 20, "Nimm 3", Color.YELLOW);
        lblAusgabe = new Label(50, 170,100, 20, sp1AmZug, Color.LIGHT_GRAY, false, false);
        btnNeuesSpiel = new Button(20, 240, 160, 20, "Neues Spiel", Color.RED);
        btnEnde = new Button(20, 270, 160, 20, "Programm beenden", Color.RED);
        programmEnde = false;
        nim = new NimSpiel();
        lblSteinAnzahl = new Label(10,10,100,20,"Steinanzahl: "+nim.gibAnzahl(), Color.LIGHT_GRAY, false, false);
        anzeigeIstDran();
    }
    
    
    public void anzeigeIstDran() {
        int amZug = nim.istDran();
        if (amZug==1) {
            lblAusgabe.setLabelText(sp1AmZug);
        } else {
            lblAusgabe.setLabelText(sp2AmZug);
        }
    }
    
    public void anzeigeSieger(int pSieger) {
      if (pSieger==1) {
         lblAusgabe.setLabelText("Sieger Spieler 1");
      } else if (pSieger==2) {
         lblAusgabe.setLabelText("Sieger Spieler 2");  
        }
    }
    
    public void btnNimAktion(int pAnzahl) {
      nim.ziehen(pAnzahl);
      lblSteinAnzahl.setLabelText("Steinanzahl: "+nim.gibAnzahl());    
      anzeigeIstDran();
      anzeigeSieger(nim.gibSieger());
    }
    
    public void btnNeuesSpielAktion() {
       nim.neuesSpiel();
       lblSteinAnzahl.setLabelText("Steinanzahl: "+nim.gibAnzahl());
       anzeigeIstDran();
    }
    
    
    public void spielen() {
        while (!programmEnde) {
            if (btnNim1.clicked()) {
                btnNimAktion(1);
            }           
            if (btnNim2.clicked()) {
               btnNimAktion(2);
            }
            if (btnNim3.clicked()) {
               btnNimAktion(3);
            }
            if (btnNeuesSpiel.clicked()) {
               btnNeuesSpielAktion();
            }
            if (btnEnde.clicked()) {
               programmEnde = true;
            }
            view.wait(10);
        }
    }
}    


