
/**
 * Verwaltet den Spielstand, prüft die Züge und ermittelt den Sieger
 * 
 * @author Klaus Dingemann
 * @version 09.02.2018
 */
import sas.*;
public class NimSpiel
{
    final int MAXSTEINE = 15;
    boolean spieler1AmZug;  
    int anzahlSteine;

    public NimSpiel() {
        spieler1AmZug = true;
        anzahlSteine = MAXSTEINE;
    }

    public void ziehen(int pAnzahl) {
        if (pAnzahl<=anzahlSteine) {
            anzahlSteine = anzahlSteine - pAnzahl;
            spieler1AmZug = !spieler1AmZug;
        } 
    }
    
    public void computerZug() {
      int weg = anzahlSteine % 4;
      if (weg != 1) {
          //Nur wenn weg ungleich 1 ist, hat der Spieler nicht optimal gespielt
          weg = (weg + 3) % 4;
          //weg = weg - 1 wäre falsch beim Rest 0
      }
      Tools.message("Computer nimmt "+weg,"Computerzug");
      ziehen(weg);
    }
    
    public int gibAnzahl() {
        return anzahlSteine;
    }
    
    public int istDran() {
        if (spieler1AmZug) {
            return 1;
        } else  {
            return 2;
        }
    }
    
    public void neuesSpiel() {
      anzahlSteine = MAXSTEINE;
      spieler1AmZug = true;
    }
    
    public int gibSieger() {
        if (anzahlSteine == 0) {
            if (spieler1AmZug) {
                return 1;
            } else {
                return 2;
            }
        } else {
            return 0;
        }
    }    
   
    

}
