
/**
 * EIn Objekt dieser KLasse ist eine Kachel einer gerasterten Fläche
 * 
 * @author Klaus Dingemann
 * @version 10.01.2018
 */
import java.awt.Color;
import sas.*;
public class Kachel
{
    private int x;
    private int y;
    private Color farbe;
    private boolean hindernis;
    private Rectangle rechteck;

    /**
     * Konstruktor für Objekte der Klasse Kachel.
     * Erzeugt eine Kachel der angegebenen Breite, Höhe und Farbe an der angegebenen Position.
     * @param pX: x-Position in Pixel
     * @param pY: y-Position in Pixel
     * @param pKachelBreite: Breite der Kachel in Pixel
     * @param pKachelHooehe: Höhe der Kachel iin Pixel
     * @param pFarbe: Kachelfarbe
     */
    public Kachel(int pX, int pY, int pKachelBreite, int pKachelHoehe, Color pFarbe)
    {
        x = pX;
        y = pY;
        farbe = pFarbe;
        hindernis = false;
        rechteck = new Rectangle(pX*pKachelBreite+1, pY*pKachelHoehe+1, pKachelBreite - 2, pKachelHoehe - 2, pFarbe);
    }

    public void setzeFarbe(Color pFarbe) {
        rechteck.setColor(pFarbe);
    }
   
    public void setzteHindernis(Color pHindernisFarbe) {
      hindernis = true;
      rechteck.setColor(pHindernisFarbe);
    }
    
    public void entferneHindernis() {
        hindernis = false;
        rechteck.setColor(farbe);
    }
    
    public boolean istHindernis() {
        return hindernis;
    }
    
    public int gibX() {
        return x;
    }
    
    public int gibY() {
        return y;
    }
}
