
/**
 * Klasse zur Erzeugung der beiden Spielfiguren
 * 
 * @author Klaus Dingemann
 * @version 18.01.2018
 */

import sas.*;
public class Person
{
     Picture person;
     Schatzkammer schatzkammer;
     int posX;
     int posY;
    /**
     * Erzeugt das Objekt, lädt die Grafik der Spielfigur und bewegt sie auf die Anfangsposition.
     */
    public Person(int pSpalte,  int pZeile, int pBreite, int pHoehe, String pBild, Schatzkammer pSchatzkammer)
    {
       posX = pSpalte;
       posY = pZeile;
       person = new Picture (0, 0, pBreite,pHoehe,pBild);
       schatzkammer = pSchatzkammer;
       person.moveTo(schatzkammer.kachelXInPixelX(pSpalte), schatzkammer.kachelYInPixelY(pZeile));
    }

    
    /**
     * Bewegt wenn möglich die Spielfigur in die angegebene Richtung.
     * @param pRichtung: gibt die Richtung der Bewegung an 'r':rechts, 'l': links, 'u': unten, 'o': oben
     */
    public void bewege(char pRichtung) {
        if (pRichtung == 'r' && schatzkammer.istInnen(posX+1,posY) && !schatzkammer.istHindernis(posX+1, posY)){
            posX = posX + 1;
        } else if (pRichtung == 'l' && schatzkammer.istInnen(posX-1,posY) && !schatzkammer.istHindernis(posX-1, posY)){
            posX = posX - 1;
        } else if (pRichtung == 'u' && schatzkammer.istInnen(posX,posY+1) && !schatzkammer.istHindernis(posX, posY+1)){
            posY = posY + 1;
        } else if (pRichtung == 'o' && schatzkammer.istInnen(posX,posY-1) && !schatzkammer.istHindernis(posX, posY-1)){
            posY = posY - 1;
        }
        person.moveTo(schatzkammer.kachelXInPixelX(posX), schatzkammer.kachelYInPixelY(posY));
    }
    
    /**
     * Liefert die X-Koordinate des Objekts auf der Rasterfläche
     */
    public int gibX(){
        return posX;
    }
    
    /**
     * Liefert die Y-Koordinate der Person auf der Rasterfläche.
     */
    public int gibY(){
        return posY;
    }
}
