/**
 * Bei diesem Spiel muss ein Abenteuerer Schätze auf einer 15x15 Spielfläche einsammeln.
 * Der Wächter muss dies verhindern, indem er den Abenteuerer fängt. Die Spielfläche
 * enthält in jeder Zeile eine Schatz und zufällig verteilte Hindernisse. Die Spielfiguren
 * werden mit den Pfeiltasten bzw. den Tasten 'd', 'e', 'f', 's' im Spielfeld bewegt.
 * 
 * @author Klaus Dingemann
 * @version 10.01.2018
 */
import sas.*;
import java.awt.Color;
public class Schatzsuche
{
    public final int ZEILEN = 15;
    public final int SPALTEN = 15;
    public final int KACHELGROESSE = 30;
    View view;
    Person waechter;
    Person abenteurer;
    Person sieger = null;
    Schatzkammer schatzkammer;


    /**
     * Konstruktor für Objekte der Klasse Schatzsuche. Erzeugt die erforderlichen Objekte.
     */
    public Schatzsuche()
    {
        view = new View( ZEILEN*KACHELGROESSE, SPALTEN*KACHELGROESSE, "Schatzsuche");
        schatzkammer = new Schatzkammer(SPALTEN, ZEILEN, KACHELGROESSE * SPALTEN, KACHELGROESSE * ZEILEN);
        waechter = new Person(5,0,KACHELGROESSE-2, KACHELGROESSE-2,"waechter.png", schatzkammer);
        abenteurer = new Person(5,ZEILEN-1,KACHELGROESSE-2, KACHELGROESSE-2,"abenteurer.png", schatzkammer);
    }

    /**
     * steuert das Spiel
     */    
    public void spielen(){
        while (!spielBeendet()){
            if (view.keyDownPressed()) {
                abenteurer.bewege('u');
            }
            if (view.keyUpPressed()) {
                abenteurer.bewege('o');
            }
            if (view.keyRightPressed()) {
                abenteurer.bewege('r');
            }
            if (view.keyLeftPressed()) {
                abenteurer.bewege('l');
            }
            if (view.keyPressed('d')) {
                waechter.bewege('u');
            }
            if (view.keyPressed('e')){
                waechter.bewege('o');
            }
            if (view.keyPressed('f')) {
                waechter.bewege('r');
            }
            if (view.keyPressed('s')) {
                waechter.bewege('l');
            } 
          
            view.keyBufferDelete();
            
            schatzkammer.entferneSchatz(abenteurer.gibX(), abenteurer.gibY());
            view.wait(10);
        }
        ergebnisAnzeigen();
    }
    
    /**
     * Liefert true, wenn das Spiel beendet ist, weil alle Schätze aufgesammelt wurden oder
     * der Wächter den Abenteurer gefangen hat.
     */
    public boolean spielBeendet(){
        boolean ende = false;
        if (schatzkammer.gibAnzahlSchaetze() == 0) {
            ende = true;
            sieger = abenteurer;
        } else {
            if (abenteurer.gibX() == waechter.gibX() && abenteurer.gibY() == waechter.gibY()) {
              ende = true;
              sieger = waechter;
            }
        }
         return ende;
    }
         
    /**
     * Öffnet ein Nachrichtenfenster mit Angabe des Siegers.
     */
    public void ergebnisAnzeigen(){
        if (sieger == abenteurer) {
           Tools.message("Der Abenteurer hat gewonnen","Sieger");
        } else {
            Tools.message("Der Wächter hat den Abenteurer gefangen","Nachricht");
        }
    }
    
    public static void main() {
      Schatzsuche schatzS = new Schatzsuche();
      schatzS.spielen();
    }
}
