
/**
 * Erzeugt das Sudoku-Spielfeld als UNterklasse der KLasse Rasterfläche
 * 
 * @author Klaus Dingemann
 * @version 24.02.2018
 */
import sas.*;
import sasio.*;
import java.awt.Color;
public class Spielfeld extends Rasterflaeche
{
    private SudokuFeld[] felder; 
    
    public Spielfeld()
    {
        super(9,9,450.0,450.0,Color.WHITE);
        new Rectangle(0, 0, 450, 2);
        new Rectangle(0, 149, 450, 3);
        new Rectangle(0, 299, 450, 3);
        new Rectangle(0, 448, 450, 2);
        new Rectangle(0, 0, 2, 450);
        new Rectangle(149, 0, 3, 450);
        new Rectangle(299, 0, 3, 450);
        new Rectangle(448, 0, 2, 450);
        String[] sudo = StringFileTools.loadFileInStringArray("sudoku.sud"); 
        int anzahl = sudo.length;
        int nr = Tools.randomNumber(0,anzahl-1);
        felder = new SudokuFeld[81];
        for (int i = 0; i<81; i++) {
            int x = i % 9;
            int y = i / 9;
            String kennzeichen = sudo[nr].substring(i*2,i*2+1);
            String loesung = sudo[nr].substring(i*2+1,i*2+2);
            boolean fix = false;
            if (kennzeichen.equals("#")) {
                fix = true;
            }
            felder[i] = new SudokuFeld(new Position(x, y), loesung, fix);
        }
    }
    
    public void bearbeiteHilfe(Position pPos, int pZahl) {
      int index = pPos.gibYPosition()*9 + pPos.gibXPosition();
      felder[index].zeigeVersteckeHilfe(pZahl-1);
    }
      
    public void bearbeiteZahl(Position pPos, int pZahl) {
      int index = pPos.gibYPosition()*9 + pPos.gibXPosition();
      felder[index].zeigeVersteckeZahl(pZahl);
    }
    
 
    public boolean istFix(Position pPos) {
        int index = pPos.gibYPosition()*9 + pPos.gibXPosition();
        return felder[index].istFix();
    }
    
    public void pruefen() {
      for (int i=0; i<81; i++) {
        felder[i].pruefe();
      }
    }
    

}
