
/**
 * Beschreiben Sie hier die Klasse Sudoku.
 * 
 * @author (Ihr Name) 
 * @version (eine Versionsnummer oder ein Datum)
 */
import sas.*;
import sasio.*;
import java.awt.Color;
public class Sudoku
{
    private Spielfeld spielfeld;
    private View view;
    private Position markierung;
    private Button[] btnZahlen;
    private Button btnHilfen;
    private Button btnEingaben;
    private Button btnPruefen;
    
    public Sudoku()
    {
       view = new View(451, 550, "Sudoku");
       spielfeld = new Spielfeld();
       btnZahlen = new Button[9];
       for (int i = 0; i<9; i++) {
         int zahl = i+1;
         btnZahlen[i] = new Button(5+i*49, 455, 45, 45, ""+zahl, new Color(255,246,143));
         
       }    
       btnHilfen = new Button(5, 505, 140, 40, "Hilfen", new Color(191,239,255));
       btnEingaben = new Button(154, 505, 140, 40, "Zahlen",new Color(191,239,255));
       btnPruefen = new Button(304, 505, 140, 40, "Prüfen", new Color(191,239,255));
       btnHilfen.setActivated(false);
       int x = 0;
       int y = 0;
       markierung = new Position(x,y);
       while (spielfeld.istFix(markierung) && x < 9 && y < 9){
           x = x + 1;
           if (x == 9) {
             x = 0;
             y = y + 1;
           }
           markierung.setzePosition(x,y);
       }    
       spielfeld.setzeHindernis(markierung.gibXPosition(),markierung.gibYPosition(), Color.PINK);
    }

    private void kachelKlickAktion(Position pPos) {
        if (!spielfeld.istFix(pPos)) {      
              int x = pPos.gibXPosition();
              int y = pPos.gibYPosition();
              spielfeld.entferneHindernis(markierung.gibXPosition(), markierung.gibYPosition());
              spielfeld.setzeHindernis(pPos.gibXPosition(),pPos.gibYPosition(), Color.PINK);
              markierung.setzePosition(x, y);
        }
    }
    
    private void btnZahlenAktion(int pZahl) {
      if (!btnHilfen.getActivated()) {
          spielfeld.bearbeiteHilfe(markierung, pZahl);
      } else {
          spielfeld.bearbeiteZahl(markierung, pZahl);
     }
    }
    
    private void btnHilfenAktion() {
      btnHilfen.setActivated(false);
      btnEingaben.setActivated(true);
    }
    
    private void btnEingabenAktion() {
      btnHilfen.setActivated(true);
      btnEingaben.setActivated(false);
    }
    
    private void btnPruefenAktion() {
      spielfeld.pruefen();
    }
    
    public void spielen() {
        while (true) {
          Position pos = spielfeld.gibKlickKachel();
          if (pos.gibXPosition()!=-1) {
              kachelKlickAktion(pos);
           }
          for (int i = 0; i<9; i++) {
              if (btnZahlen[i].clicked()) {
                 btnZahlenAktion(i+1);
              }
          if (btnHilfen.clicked()) {
              btnHilfenAktion();
          }
          if (btnEingaben.clicked()) {
              btnEingabenAktion();
          }
          if (btnPruefen.clicked()) {
             btnPruefenAktion();
          }
          view.wait(10);
         }
       }
    }
    
    public static void main() {
      Sudoku sud = new Sudoku();
      sud.spielen();
    }
}
