
/**
 * Autor: Klaus Dingemann, Münster
 * Version: 25.01.2018
 */
import sas.*;
import java.awt.Color;
class TangramVogel
{
   private View view;
   private Polygon[] grundfigur =  new Polygon[7];
   private Polygon figur;
  
   public TangramVogel()
   {
      view = new View(500, 500, "Tangram");
      view.setBackgroundColor(Color.BLACK);
      figur = gibFigur();
      Text anleitung = new Text(130, 450, "Mit Mausklick drehen." , Color.RED);
      Text anleitung2 = new Text(130, 470, "Mit 'u' Parallelogramm umdrehen", Color.RED);
      anleitung.setFontSansSerif(true, 12);
      anleitung2.setFontSansSerif(true, 12);
      grundfigur[0] = gibDreieckGross(10, 80, Color.MAGENTA);
      grundfigur[1] = gibDreieckGross(10, 160, Color.RED); 
      grundfigur[2] = gibDreieckMittel(10, 240, Color.GREEN);
      grundfigur[3] = gibDreieckKlein(10, 290, Color.BLUE);
      grundfigur[4] = gibDreieckKlein(10,340,new Color(0,191,255)); 
      grundfigur[5] = gibRaute(10,390,Color.LIGHT_GRAY);
      grundfigur[6] = gibParallelogramm(10, 470, Color.YELLOW);
    }

   public Polygon gibFigur() {
     Polygon pol = new Polygon(160,300, Color.WHITE);
     double seitenlaengeKlein = 30*Math.sqrt(2);
     double seitenlaengeGross = 60*Math.sqrt(2);
     pol.add(60,0);
     pol.add(60,60-seitenlaengeGross);
     pol.add(60+seitenlaengeGross-seitenlaengeKlein,60-seitenlaengeGross);
     pol.add(60+seitenlaengeGross,60-seitenlaengeGross-seitenlaengeKlein);
     pol.add(60+seitenlaengeGross,60-seitenlaengeGross-2*seitenlaengeKlein);
     pol.add(60+seitenlaengeGross+seitenlaengeKlein,60-seitenlaengeGross-2*seitenlaengeKlein);
     pol.add(60+seitenlaengeGross+2*seitenlaengeKlein,60-seitenlaengeGross-seitenlaengeKlein);
     pol.add(60+seitenlaengeGross+seitenlaengeKlein,60-seitenlaengeGross-seitenlaengeKlein);
     pol.add(60+seitenlaengeGross,60-seitenlaengeGross);
     pol.add(60+seitenlaengeGross,60);
     pol.add(60+seitenlaengeGross/2,60);
     pol.add(90+seitenlaengeGross/2,90);
     pol.add(30+seitenlaengeGross/2,90);
     pol.add(60+seitenlaengeGross/2,60);
     pol.add(60,60);
     return pol;
   }
    
   public Polygon gibDreieckGross(double pX, double pY, Color pFarbe) {
     Polygon pol = new Polygon(pX, pY, pFarbe); 
     pol.add(120,0);
     pol.add(60, -60);
     return pol;
   }
   
   public Polygon gibDreieckMittel(double pX, double pY, Color pFarbe) {
     Polygon pol = new Polygon(pX, pY, pFarbe); 
     pol.add(60, 0);
     pol.add(60, -60);
     return pol;
   }
   
   public Polygon gibDreieckKlein(double pX, double pY, Color pFarbe) {
     Polygon pol = new Polygon(pX, pY, pFarbe); 
     pol.add(60,0);
     pol.add(30, -30);
     return pol;
   }
   
   public Polygon gibRaute(double pX, double pY, Color pFarbe) {
     Polygon pol = new Polygon(pX, pY, pFarbe); 
     pol.add(30,-30);
     pol.add(60, 0);
     pol.add(30,30);
     return pol;
   }
   
    public Polygon gibParallelogramm(double pX, double pY, Color pFarbe) {
     Polygon pol = new Polygon(pX, pY, pFarbe); 
     pol.add(60,0);
     pol.add(90, -30);
     pol.add(30, -30);
     return pol;
   }
   
   public int getDraggedIndex(){
      int index=-1;
      int zaehler = 0;
      while (index == -1 && zaehler<7) {  
        if (grundfigur[zaehler].mouseDragged()) {
           index=zaehler;
        } else
            zaehler++;
    }
      return index;
   }
   
   public int getClickedIndex(){
       int index=-1;
      int zaehler = 0;
      while (index == -1 && zaehler<7) {            
        if (grundfigur[zaehler].mouseClicked()) {
           index=zaehler;
        } else
            zaehler++;
    }
      return index;
   }
     
            
   public void fuehreAus(){
     while (!view.keyPressed('q')){
         if (view.keyPressed('u')) {
            grundfigur[6].flipHorizontal();
            view.keyBufferDelete();
         }
         int index = getClickedIndex();
         if (index!=-1){
             grundfigur[index].turn(45);
             index=-1;
          }
          int index2 = getDraggedIndex();
          if (index2!=-1) {
              int altX = grundfigur[index2].getMouseX();
              int altY = grundfigur[index2].getMouseY();
              int neuX = grundfigur[index2].getMouseX();
              int neuY = grundfigur[index2].getMouseY();
              while (grundfigur[index2].mouseDragged()){
                 grundfigur[index2].move(neuX-altX, neuY-altY);
                 altX = neuX;
                 altY = neuY;  
                 neuX = grundfigur[index2].getMouseX();
                 neuY = grundfigur[index2].getMouseY();      
              }
          }
           view.wait(10);
       }
    } 
       
    public static void main() {
      TangramVogel tg = new TangramVogel();
      tg.fuehreAus();
    }
    
}