
/**
 * Erzeugt das TicTacToe-Spielfeld als UNterklasse der KLasse Rasterfläche
 * 
 * @author Klaus Dingemann
 * @version 24.02.2018
 */
import sas.*;
import java.awt.Color;
public class Spielfeld extends Rasterflaeche
{
    int[] spielsteine; 
    
    public Spielfeld()
    {
        super(3,3,450.0,450.0,Color.WHITE);
        spielsteine = new int[9];
        for (int i = 0; i<9; i++) {
            spielsteine[i] = 0;
        }
    }
    
    private boolean feldBelegt(Position pPos) {
        int x = pPos.gibXPosition();
        int y = pPos.gibYPosition();
        int index = 3*y+x;
        return spielsteine[index] != 0;
    }
 
        
    public void setzeKreuz(Position pPos) {
      if (!feldBelegt(pPos)) {
        int x = pPos.gibXPosition();
        int y = pPos.gibYPosition();
        Kreuz kreuz = new Kreuz (pPos);
        int index = 3*y+x;
        spielsteine[index] = 1;
      }
    }
    
    public void setzeKreis(Position pPos) {
      if (!feldBelegt(pPos)) {
        int x = pPos.gibXPosition();
        int y = pPos.gibYPosition();
        Kreis kreis = new Kreis (pPos);
        int index = 3*y+x;
        spielsteine[index] = 2;
      }
    }
      
    private boolean hatGewonnen(int pNr) {
      boolean gewonnen = false;
      for (int i = 0; i<3; i++) {
        if ((spielsteine[i*3]==pNr && spielsteine[i*3+1]==pNr && spielsteine[i*3+2]==pNr) ||
           (spielsteine[i]==pNr && spielsteine[i+3]==pNr && spielsteine[i+6]==pNr)) {
           gewonnen = true;
        }
      } 
      if (!gewonnen) {
        gewonnen =  (spielsteine[0]==pNr && spielsteine[4]==pNr && spielsteine[8]==pNr)||
        (spielsteine[2]==pNr && spielsteine[4]==pNr && spielsteine[6]==pNr);
      }
      return gewonnen;
    }
    
    public int spielBeendet() {
        int ende = -1;
        boolean alleBelegt = true;
        for (int i = 0; i<9 ;i++) {
            if (spielsteine[i]==0) {
                alleBelegt = false;
            }
        }
        if (alleBelegt) {
            ende = 0;
        } else if (hatGewonnen(1)) {
            ende = 1;
        } else if (hatGewonnen(2)) {
            ende = 2;
        }
        return ende;
    }
    

}
