
/**
 * Das Programm ist eine Variante des Spiels Galgenmännchen
 * 
 * @author Klaus Dingemann
 * @version 01.03.2018
 */
import sas.*;
import sasio.*;
import java.awt.Color;
public class WortRaten
{
    private final String buchstaben = "ABCDEFGHIJKLMNOPQRSTUVWXYZÄÖÜ";
    private View view;
    private Button[] btnBuchstaben;
    private Button btnNeuesWort;
    private int versuche;
    private int wortLaenge;
    private Label lblVersuche;
    private Ratewort ratewoerter;
    private String ratewort;
    private Label[] lblRatebuchstaben;
    private Textfield txtfldLoesung;
    private Label lblLoesung;
    private boolean ende;
  
    public WortRaten()
    {
        view = new View(890,200, "Wörter raten");
        view.setBackgroundColor(Color.LIGHT_GRAY);
        btnBuchstaben = new Button[buchstaben.length()];
        for (int i = 0; i < buchstaben.length(); i++) {
            String bstb = buchstaben.substring(i,i+1);
            btnBuchstaben[i] = new Button(10+i*30,160, 20, 20,bstb, Color.YELLOW);
        }
        btnNeuesWort = new Button(20,20,80,20,"Neues Wort",Color.RED);
        lblRatebuchstaben = new Label[0];
        lblVersuche = new Label (760, 20,100, 30, "Versuche: 0",Color.LIGHT_GRAY,false,false);
        versuche = 0;
        ende = false;
        ratewoerter = new Ratewort();
        lblLoesung = new Label(320, 120, 60, 20, "Lösung: ",Color.LIGHT_GRAY,false, false);
        txtfldLoesung = new Textfield(380, 110, 100, 30,"", view);
    }

    public void btnNeuesWortAktion() {
      for (int i = 0; i<lblRatebuchstaben.length; i++) {
           view.remove(lblRatebuchstaben[i]);
       }
      wortLaenge = 0;
      do {
       String wortLaengeString = Tools.inputDialog("Anzahl der Buchstaben (mindestens 3)");
       if (wortLaengeString!=null) {
           wortLaenge = Tools.stringToInt(wortLaengeString);
           if (wortLaenge > 2) {
             ratewort = ratewoerter.gibWort(wortLaenge).toUpperCase();
             lblRatebuchstaben = new Label[wortLaenge];
             for (int i = 0; i < wortLaenge; i++) {
                lblRatebuchstaben[i]=new Label((890-40*wortLaenge)/2+i*40, 60, 20, 20, "", Color.WHITE, false, true);
             }
             versuche = 8;

             lblVersuche.setLabelText("Versuche: "+versuche);
           }
       } else {
           ende = true;
        }
      } while (wortLaenge < 3 && !ende);
    }
    
    public void btnBuchstabeAktion(String buchstabe) {
        versuche = versuche - 1;
        txtfldLoesung.setActivated(false);
        for (int i = 0; i < wortLaenge; i++) {
            if (ratewort.substring(i,i+1).equals(buchstabe)) {
                lblRatebuchstaben[i].setLabelText(buchstabe);
            }
        }
        lblVersuche.setLabelText("Versuche: "+versuche);
    }
    
    public void txtfldLoesungAktion() {
        txtfldLoesung.setActivated(true);
        while (!txtfldLoesung.enterPressed()){
            view.wait(20);
        }
        versuche = versuche - 1;
    }
    
    public void spielen() {
        boolean erraten;
        while (!ende) {
         erraten = false;
         btnNeuesWortAktion();
         txtfldLoesung.deleteText();
         while (!erraten && versuche>0 && !ende) {
          for (int i = 0; i < btnBuchstaben.length; i++) {
              if (btnBuchstaben[i].clicked()) {
                  btnBuchstabeAktion(btnBuchstaben[i].getButtonText());
              }
          }
          if (btnNeuesWort.clicked()) {
            btnNeuesWortAktion();
          }
          if (txtfldLoesung.clicked()) {
            txtfldLoesungAktion();
          }
          if (ratewort.equals(txtfldLoesung.getText().toUpperCase())) {
              erraten = true;
          }
        }  
        if (!ende) {
          if (!erraten) {
             Tools.message("Lösung:" +ratewort, "Leider verloren");
          } else { 
              Tools.message("Wort erraten", "Glückwunsch");
          }
        }
     } 
     System.exit(0);
  }
  
  public static void main() {
      WortRaten wr = new WortRaten();
      wr.spielen();
      System.exit(0);
  }
}
