 


/**
 * Die Klasse Roehre stellt die beiden Roehren-Teile als Rectanglee dar, durch 
 * die der Vogel fliegen muss.
 * 
 * @author Klaus Dingemann
 * @version (03.09.2017)
 */
import java.awt.Color;
import sas.*;
public class Hindernis 
{
   private Picture hindernisOben;
   private Picture hindernisUnten;
   private Sprite hindernis;

    /**
     * Erstellt zwei Roehren  - oben und unten
     * 
     * @param x x-Koordinate für die linke obere Ecke der oberen Roehre
     */
   
    public Hindernis(int pXPosition)
    {
        int oben = Tools.randomNumber(-400,-50);
        hindernisOben = new Picture(pXPosition, oben, 50,450,"rinde.png");
        hindernisUnten = new Picture(pXPosition, oben+600, 50,450,"rinde.png");
        hindernis = new Sprite();
        hindernis.add(hindernisOben);
        hindernis.add(hindernisUnten);
    }
  
    public Sprite gibBild() {
        return hindernis;
    }
    
    public boolean kollision(Vogel pVogel) 
    {
        if (hindernisOben.intersects(pVogel.gibPicture()) || 
            hindernisUnten.intersects(pVogel.gibPicture())){
            return true;
        } else {
            return false;
        }
    }
     
    public boolean durchflogen(Vogel pVogel) {
        return pVogel.gibPicture().getShapeX() > hindernis.getShapeX() + 50;
    }
}
