 /**
 * Die Klasse Spiel startet das Spiel und reagiert auf Tastatureingaben.
 * 
 * @author Klaus Dingemann 
 * @version 19.02.17
 */

import java.awt.Color;
import sas.*;
import sasio.*;
public class SillyBird
{   
    final static String DATEINAME = "sillybird.txt";
    private View view;
    private Landschaft landschaft;
    private Vogel vogel;
    private int punkte;
    private Text ausgabePunkte;

 
    public SillyBird() {
         view = new View(800, 600, "Vogel flieg");
         punkte = 0;
         landschaft = new Landschaft();
         vogel = new Vogel();
         ausgabePunkte = new Text(5, 20,"Punkte: 0", Color.RED);
    }
    
    /**
     * Laeuft solange, bis das Spiel mit ESC unterbrochen wurde oder der 
     * Vogel mit einem Hindernis kollidiert ist.
     * 
     */
    public void spielen() 
    {        
        int weiter = 1;
        do {
          boolean spielBeendet = false;
          view.wait(2000);
          while(!spielBeendet) {
            landschaft.bewegen(-2);
            vogel.bewegen(7);
            if(view.keyUpPressed()){
              vogel.bewegen(-12);
            } 
            if (landschaft.kollision(vogel)) {
              spielBeendet = true;
            } else if (landschaft.hindernisPassiert(vogel)) {
                punkte = punkte + 1;
                zeigePunktestand();
            }
            view.wait(30);
         }
         highScoreSpeichern();
         weiter = Tools.confirmDialog("Noch ein Spiel");
          if (weiter==0) {
            this.ausgangsposition();
            spielBeendet = false;
          }
        } while (weiter==0);
        System.exit(0);
    }
  
    public void ausgangsposition() {
       view.keyBufferDelete();
       vogel.setzeInAusgangsposition();
       landschaft.setzeInAusgangsposition();
       punkte = 0;
       zeigePunktestand();
    }
    
    public void zeigePunktestand() {
            ausgabePunkte.setText("Punkte: "+punkte);
     }
     
    public void highScoreSpeichern(){
        boolean neuSpeichern = true;
        String[] highScore = new String[2];
        if (StringFileTools.fileExists(DATEINAME)) {
            highScore = StringFileTools.loadFileInStringArray(DATEINAME);
            if (punkte <= Tools.stringToInt(highScore[1])) {
                neuSpeichern = false;
            }
        } 
        if (neuSpeichern) {
            String name = Tools.inputDialog("Du hast mit "+punkte+" Punkten eine neue Bestleistung aufgestellt."+
            "\n Gib deinen Namen ein:");
            if (name!=null) {
                StringFileTools.writeInFile(DATEINAME, name);
                StringFileTools.appendToDatei(DATEINAME, ""+punkte);
            }
        } else {
            Tools.message("Die Bestleistung beträgt "+highScore[1]+" Punkte und wird gehalten von "+highScore[0],"Mitteilung");
        }
    }        
            
            
         
    static void main(){
       SillyBird vf = new SillyBird();
       vf.spielen();
    }
}
